/*---------------------------------------------------------------------------/

main.h:		Universal definitions.
started:	21:11:1987

/---------------------------------------------------------------------------*/

#define LINELEN 80
#define WORDLEN 20
#define NO_SYNONYMS 10
#define NO_DIRECTIONS 8
#define SIG_LETTERS 4

#define DELETE 8
#define BEEP 7

/*--------------------------------------------------------------------------*/

typedef int wayout [NO_DIRECTIONS];

typedef char synonym [WORDLEN];

typedef struct
{
  int wordc;
  synonym wordv [NO_SYNONYMS];
} meaning;

typedef struct
{
  char *description;
  char *name;
  wayout exits;
  int seen;
} location;

typedef struct
{
  char *description;
  meaning name;
  meaning adj;
  int location;
  int value;
  int weight;
  int size;
  int flag;
  int container;
  int seen;
} object;

/*---------------------------------------------------------------------------/

NOTE: Significance of "container" field in object structure.

bit 0 : if 0, then object is opaque;
        if 1, then object is transparent;
bit 1 : if 0, then object is closed;
        if 1, then object is open;
bit 2 : if 0, then object is fixed (unopenable);
        if 1, then object is mobile (openable);
bit 3 : if 0, then object is a container;
        if 1, then object is a surface;

Thus, for instance, value 5 signifies a trasparent, closed, openable
container, maybe a glass case?

/---------------------------------------------------------------------------*/

typedef struct
{
  char *description;
  char *name;
  char abbrev [2];
} direction;

/*--------------------------------------------------------------------------*/

extern int argc;
extern char **argv;

extern int no_locations;
extern int no_objects;
extern int no_meanings;
extern int no_directions;
extern int no_articles;
extern int no_prepositions;

extern location **locations;
extern object **objects;
extern meaning **meanings;
extern direction **directions;
extern meaning articles;
extern meaning prepositions;

extern int whereami;
extern int score;
extern int stamina;
extern int load;
extern int no_moves;
extern int mode;

extern char verb [LINELEN];
extern char verbcode [LINELEN];
extern int verbindex;

/*--------------------------------------------------------------------------*/
