/*---------------------------------------------------------------------------/

parse.c:        Module to get input, break down into words etc.
started:	22:11:1987

/---------------------------------------------------------------------------*/

#include <stdio.h>
#include <ctype.h>
#include <strings.h>
#include "main.h"
#include "parse.h"
#include "verbs.h"
#include "testing.h"
#include "lex.h"
#include "y.tab.h"

/*--------------------------------------------------------------------------*/

char inputline [LINELEN];
char *rest_of_line;
char tempword [LINELEN];
char verb [LINELEN];
char verbcode [LINELEN];
int verbindex;

/*--------------------------------------------------------------------------*/

char *skipspaces (line)
  char *line;
{
  char *temp;
  temp = line;
  while (isspace (*temp))
    temp++;
  return (temp);
}

/*--------------------------------------------------------------------------*/

int getword (word)
  char *word;
{
  int retval;
  retval = sscanf (rest_of_line, "%s", word);
  rest_of_line = skipspaces (rest_of_line);
  rest_of_line += strlen (word);
  return (retval);
}

/*--------------------------------------------------------------------------*/

int codenoun (here, noun)
  char *noun;
{
  int i, j, code = 0;
  for (i=1; i<=no_objects; i++)
  {
    if (objects [i]->location == here && objects [i]->container & 10)
      code = codenoun (-i, noun);
    if (!code)
      for (j=1; j<=objects [i]->name.wordc; j++)
        if (!strncmp (noun, objects [i]->name.wordv [j], SIG_LETTERS))
          if (objects [i]->location == here || !code)
	    code = i;
  }
  return (code);
}

/*--------------------------------------------------------------------------*/

void lowerword (newword, oldword)
  char *newword;
  char *oldword;
{
  int i;
  strcpy (newword, oldword);
  for (i=0; i<strlen (oldword); i++)
    if (isupper (oldword [i]))
      newword [i] = tolower (oldword [i]);
}

/*--------------------------------------------------------------------------*/

int verbis (thisverb)
  char *thisverb;
{
  return (!strncmp (verbcode, thisverb, SIG_LETTERS));
}

/*--------------------------------------------------------------------------*/

int handle ()
{
  int i, j;
  verbindex = 0;
  lowerword (verbcode, verb);
  for (i=1; i <= no_directions; i++)
    if (verbis (directions [i]->abbrev) || verbis (directions [i]->name))
      verbindex = go (i);
  if (!verbindex)
  {
    for (i=1; i <= no_meanings; i++)
      for (j=1; j <= meanings [i]->wordc; j++)
        if (verbis (meanings [i]->wordv [j]))
  	  verbindex = i;
    if (verbindex)
    {
      strcpy (verbcode, meanings [verbindex]->wordv [1]);
      if (verbis ("inventory"))  verbindex +=(no_meanings*inventory ());
      if (verbis ("score"))      verbindex +=(no_meanings*printscore ());
      if (verbis ("object"))     verbindex +=(no_meanings*listobjinter ());
      if (verbis ("take"))       verbindex +=(no_meanings*take ());
      if (verbis ("drop"))       verbindex +=(no_meanings*drop ());
      if (verbis ("verbose"))    verbindex +=(no_meanings*verbose ());
      if (verbis ("brief"))      verbindex +=(no_meanings*brief ());
      if (verbis ("superbrief")) verbindex +=(no_meanings*superbrief ());
      if (verbis ("exits"))      verbindex +=(no_meanings*exits ());
      if (verbis ("noexits"))    verbindex +=(no_meanings*noexits ());
      if (verbis ("examine"))    verbindex +=(no_meanings*examine ());
    }
  }
  if (!verbindex)
    printf ("I don't know how to %s something.\n", verb);
  return (verbindex);
}

/*--------------------------------------------------------------------------*/

int getinput ()
{
  int token;
  if (strcmp (yytext, "."))
    printf ("\n[Turn %d]:> ", no_moves);
  if (!yyparse () && !feof (stdin))
  {
    printf ("Grammatically OK already!\n");
    no_moves++;
  }
}

/*--------------------------------------------------------------------------*/

/*
  if (getword (verb)!=EOF)
    no_moves+=handle ()/no_meanings;
  else
    if (!feof (stdin))
      printf ("It helps to type something else before you press <RETURN>\n");
*/

