/*---------------------------------------------------------------------------/

testing.c:	Testing module for adventure game - lists locations, objects
                etc. at the drop of a frog.
started:	22:11:1987

/---------------------------------------------------------------------------*/

#include <stdio.h>
#include "main.h"
#include "testing.h"
#include "y.tab.h"
#include "lex.h"

/*--------------------------------------------------------------------------*/

int listlocation (here)
  int here;
{
  int i, j;
  printf ("\nLocation #%d:\n", here);
  printf ("Description:\n%s\n", locations [here]->description);
  printf ("Name:\n%s\n", locations [here]->name);
  printf ("Exits:\n");
  j = 0;
  for (i=1; i<=NO_DIRECTIONS; i++)
    if (locations [here]->exits [i])
    {
      printf ("Direction %d goes to location %d\n", i, locations [here]->exits [j]);
      j++;
    }
  if (!j)
    printf ("None.\n");
  printf ("Seen value is %d.\n\n", locations [here]->seen);
  return (1);
}

/*--------------------------------------------------------------------------*/

int listobject (x)
  int x;
{
  int i;
  int retval = 0;
  if (0 < x && x <= no_objects)
  {
    retval = 1;
    printf ("\nObject number %d: a %s.\n", x, objects [x]->description);
    printf ("Adjectives that refer to it are: ");
    for (i=1; i<=objects [x]->adj.wordc; i++)
      printf ("%s, ", objects [x]->adj.wordv [i]);
    printf ("%c%c.\n", DELETE, DELETE);
    printf ("Nouns that refer to it are: ");
    for (i=1; i<=objects [x]->name.wordc; i++)
      printf ("%s, ", objects [x]->name.wordv [i]);
    printf ("%c%c.\n", DELETE, DELETE);
    printf ("Location  : %-6d", objects [x]->location);
    printf ("Weight : %-6d", objects [x]->weight);
    printf ("Size : %d\n", objects [x]->size);
    printf ("Container : %-6d", objects [x]->container);
    printf ("Value  : %-6d", objects [x]->value);
    printf ("Flag : %d\n", objects [x]->flag);
  }
  else
    printf ("Objects range from 1 to %d.\n", no_objects);
  return (retval);
}

/*--------------------------------------------------------------------------*/

int listobjinter ()
{
  char noun [LINELEN];
  getword (noun);
  return (listobject (atoi (noun)));
}

/*--------------------------------------------------------------------------*/

void printtype (symboltype)
  int symboltype;
{
  switch (symboltype)
  {
    case UNKNOWNWORD:	printf ("unknownword"); break;
    case CONJUNCTION:	printf ("conjunction"); break;
    case NOUN:		printf ("noun"); 	break;
    case ADJECTIVE:	printf ("adjective"); 	break;
    case VERB:		printf ("verb"); 	break;
    case METACOMMAND:	printf ("metacommand"); break;
    case ARTICLE:	printf ("article"); 	break;
    case PREPOSITION:	printf ("preposition"); break;
    case DIRECTION:	printf ("direction"); 	break;
    case SCENERY:       printf ("pseudo-noun"); break;
    case NOMORE:	printf ("NOMORE"); 	break;
    default:		printf ("VAST BUG");
  }		
}

/*--------------------------------------------------------------------------*/
