/*---------------------------------------------------------------------------/

verbs.c:        Module to handle actually doing things.
started:        25:11:1987

/---------------------------------------------------------------------------*/

#include <stdio.h>
#include "main.h"
#include "parse.h"
#include "look.h"
#include "verbs.h"

/*--------------------------------------------------------------------------*/

int go (whichway)
  int whichway;
{
  int retval = 1;
  if (locations [whereami]->exits [whichway])
  {
    retval = no_meanings;
    whereami = locations [whereami]->exits [whichway];
    describe (whereami);
  }
  else
    printf ("You can't go %s from here.\n", directions [whichway]->description);
  return (retval);
}

/*--------------------------------------------------------------------------*/

int skeleton ()
{
  int retval=0;
  int gotone=0;
  char noun [LINELEN];
  char nouncode [LINELEN];
  int nounindex;
  while (getword (noun)!=EOF)
  {
    gotone=1;
    lowerword (nouncode, noun);
    nounindex = codenoun (whereami, nouncode);
    nounindex = nounindex;

    /* Above line shuts lint up */
    /* Actually do things here */

  }
  if (!gotone)
    printf ("Please specify nouns.\n");
  return (retval);
}

/*--------------------------------------------------------------------------*/

int take ()
{
  int retval=0;
  int gotone=0;
  int parent=0;
  int nounindex;
  char noun [LINELEN];
  char nouncode [LINELEN];
  char preposition [WORDLEN];
  while (getword (noun)!=EOF)
  {
    gotone=1;
    lowerword (nouncode, noun);
    nounindex=codenoun (whereami, nouncode);
    if (!nounindex)
      printf ("I don't know what a %s is, I'm afraid.\n", noun);
    else
      if (!objects [nounindex]->location)
        printf ("You're already carrying the %s, cretin!\n", objects [nounindex]->description);
      else
        if (!visible (nounindex))
          printf ("I don't see any %s here.\n", objects [nounindex]->description);
        else
          if (!accessible (nounindex))
            printf ("You can't get at the %s.\n", objects [nounindex]->description);
          else
            if (!objects [nounindex]->flag)
              printf ("You can't pick up the %s!\n", objects [nounindex]->description);
            else
              if (load+totalweight (nounindex)>stamina)
                printf ("The %s would make your load too heavy.\n", objects [nounindex]->description);
              else
              {
                retval++;
                if (accessheld (nounindex))
                {
                  parent= -(objects [nounindex]->location);
                  if (objects [parent]->container & 8)
                    strcpy (preposition, "off");
                  else
                    strcpy (preposition, "out of");
                  printf ("You take the %s %s the %s.\n", objects [nounindex]->description, preposition, objects [parent]->description);
                }
                else
                {
                  load+=totalweight (nounindex);
                  printf ("You pick up the %s.\n", objects [nounindex]->description);
                }
                objects [nounindex]->location = 0;
              }
  }
  if (!gotone)
    printf ("You wouldn't care to be a little more specific, maybe?\n");
  return (retval);
}

/*--------------------------------------------------------------------------*/

int drop ()
{
  int retval=0;
  int gotone=0;
  int nounindex;
  char noun [LINELEN];
  char nouncode [LINELEN];
  while (getword (noun)!=EOF)
  {
    gotone=1;
    lowerword (nouncode, noun);
    nounindex=codenoun (0, nouncode);
    if (!nounindex)
      printf ("I don't know what a %s is, I'm afraid.\n", noun);
    else
      if (!visiheld (nounindex))
        printf ("You don't seem to be carrying the %s!\n", objects [nounindex]->description);
      else
        if (!accessheld (nounindex))
          printf ("You can't get at the %s.\n", objects [nounindex]->description);
        else
          if (!objects [nounindex]->flag)
            printf ("You can't drop the %s!\n", objects [nounindex]->description);
          else
          {
            retval++;
            printf ("You put down the %s.\n", objects [nounindex]->description);
            load-=totalweight (nounindex);
            objects [nounindex]->location = whereami;
          }
  }
  if (!gotone)
    printf ("You wouldn't care to be a little more specific, maybe?\n");
  return (retval);
}

/*--------------------------------------------------------------------------*/

int examine ()
{
  int retval=0;
  int gotone=0;
  char noun [LINELEN];
  char nouncode [LINELEN];
  int nounindex;
  while (getword (noun)!=EOF)
  {
    gotone=1;
    lowerword (nouncode, noun);
    nounindex=codenoun (whereami, nouncode);
    if (!nounindex)
      printf ("There is no such thing as a %s, I confidently state.\n", noun);
    else
      if (!visible (nounindex))
        printf ("I see no %s here.\n", objects [nounindex]->description);
      else
      {
        retval++;
        if (objects [nounindex]->container)
          printobject (nounindex, 0);
        else
          printf ("I see nothing special about the %s.\n", objects [nounindex]->description);
      }
  }
  if (!gotone)
    describe (whereami);
  return (retval);
}

/*--------------------------------------------------------------------------*/
