/*---------------------------------------------------------------------------/

yacc.h:        	Header file for yacc parsing module.
started:	24:01:1988

/---------------------------------------------------------------------------*/

extern int yyparse ();

/*--------------------------------------------------------------------------*/

#define DIR_NODE	1
#define META_NODE	2
#define VERB_NODE	3
#define PREP_NODE	4

/*--------------------------------------------------------------------------*/

typedef struct tempnode
{
  int nodetype;
  char *currentword;
  synonym objlist;
  struct tempnode *next;
} *node;

/*----------------------------------------------------------------------------

NOTES
=====

DIR_NODE	Contains the direction in "char *currentword", and has null 
		entry in "next".  Also has null objlist and adjlist.

META_NODE	Contains the metacommand in "char *currentword", and has 
		null entry in "next".  May have a non-null objectlist or
		adjectivelist.  Probably not both.

VERB_NODE	Contains the verb in "char *currentword", and may have
		non-null objectlist and adjlist.  May also have a pointer 
		to a node of type PREP_NODE.

PREP_NODE	Contains the preposition in "char *currentword", and must
		have a non-null objectlist.  May have a non-null adjlist.

----------------------------------------------------------------------------*/
