%{
#include <stdio.h>
#include "main.h"
#include "yacc.h"
#include "lex.h"
%}

%token CONJUNCTION
%token NOUN
%token ADJECTIVE
%token VERB
%token METACOMMAND
%token ARTICLE 
%token PREPOSITION
%token DIRECTION
%token SCENERY
%token UNKNOWNWORD

%start xxmain

%%

xxmain		: error '\n' { yyerrok; yyclearin; }
                | METACOMMAND
		| DIRECTION
		| xxverb
		|
		;

xxverb		: VERB 
		| VERB DIRECTION
		| VERB xxobjects
		| VERB PREPOSITION xxobjects
		| VERB xxobjects PREPOSITION xxobjects
		| VERB PREPOSITION xxobjects PREPOSITION xxobjects
		;

xxobjects	: xxsingle
		| xxobject xxsingle
		| xxobject CONJUNCTION xxsingle
		;

xxsingle        : xxobject
		| xxscenery
		;

xxobject	: ARTICLE xxadj NOUN
		| xxadj NOUN
		;

xxscenery       : ARTICLE xxadj SCENERY
		| xxadj SCENERY
		;

xxadj		: 
		| ADJECTIVE
		| xxadj ADJECTIVE
		;

%%

/*---------------------------------------------------------------------------*/

void yyerror (message)
  char *message;
{
  int symboltype;
  symboltype = whattype (yytext);
  if (symboltype == NOMORE)
    printf ("It doesn't make sense to end a sentence there!\n");
  else
    if (symboltype == UNKNOWNWORD)
      printf ("I don't know the word \"%s\".\n", yytext);
    else
    {
      printf ("It doesn't make sense to have the ");
      printtype (symboltype);
      printf (" \"%s\" there.\n", yytext);
    }
}

/*-----------------------------------------------------------------------------

NOTE
====

There is an obscure bug in here, such that and object list featuring a
pseudo-object (ie. an article of scenery) can have no further objects,
either with or without conjunctions.  Thus, the following are legal:

	VERB NOUN NOUN SCENERY
	VERB NOUN NOUN
	VERB SCENERY

But not the following:

	VERB NOUN SCENERY NOUN
	VERB SCENERY NOUN

-----------------------------------------------------------------------------*/

